UNIT Freq;

INTERFACE

USES Graph3d,Utility,Graph,TreeGra;

PROCEDURE DoFrequency(x,y : Word; VAR M : Matrix);

IMPLEMENTATION

CONST
     HSize = 11;
TYPE

    HArray    = Array[1..HSize] OF Word;
PROCEDURE Histogram(x,y : Word;VAR Mat : Matrix;VAR Hist : Harray);
          VAR
             Ct,Ct2,Val : Word;
          BEGIN
               ZeroFill(Hist,SizeOf(HArray));
               FOR Ct := 1 TO y DO BEGIN
                   FOR Ct2 := 1 TO x DO BEGIN
                       Val := Round(Mat[Ct,Ct2]);
                       IF Val > HSize THEN
                          Val :=  HSize;
                       IF Val <> 0 THEN
                          Inc(Hist[Val]);
                    END;
                END;
END;
PROCEDURE GraphHist(VAR Hist : HArray);
          VAR
             Max,Ct,BaseX,BaseY,i,j : Word;
             ScaleY                 : Single;
             St                     : String[4];
          BEGIN
               Max := 0;
               FOR Ct := 1 TO HSize DO
                   IF Hist[Ct] > Max THEN
                      Max := Hist[Ct];
               IF Max = 0 THEN Exit;
               IF Gd = 9 THEN
                  ScaleY := GetMaxY/(10 * Max)
               ELSE
                   ScaleY := GetMaxY/(20 * Max);
               BaseX := 1;
               BaseY := Round(Max * ScaleY)+9;
               i := 0;
               SetFillStyle(1,LightBlue);
               SetTextJustify(0,2);
               Str(Max:4,St);
               SetColor(LightGray);
               OutTextXY(78,0,St);
               Rectangle(0,8,110,BaseY+1);
               FOR Ct := 1 TO HSize DO BEGIN
                   Bar(BaseX,BaseY - Round(Hist[Ct] * ScaleY),BaseX + 6,BaseY);
                   j := Ct MOD 10;
                   Str(Ct MOD 10,St);
                   IF (j = 0) THEN BEGIN
                      Str(i,St);
                      Setcolor(LightRed);
                      Inc(i);
                   END
                   ELSE IF Ct < 11 THEN BEGIN
                       Str(j,St);
                       Setcolor(LightGray);
                   END
                   ELSE BEGIN
                       SetColor(LightGray);
                       St := '>';
                   END;
                   OutTextXY(BaseX,BaseY + 6,St);
                   Inc(BaseX,10);
               END;
END;
PROCEDURE DoFrequency(x,y : Word; VAR M : Matrix);
          VAR
             Hist : HArray;
          BEGIN
               Histogram(x,y,M,Hist);
               GraphHist(Hist);
END;
BEGIN
END.
